﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2013 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using System.Linq;
using System.Windows.Forms;
using HeuristicLab.Core.Views;
using HeuristicLab.Encodings.PermutationEncoding;
using HeuristicLab.MainForm;
using HeuristicLab.MainForm.WindowsForms;
using MIConvexHull;

namespace HeuristicLab.Analysis.AlgorithmBehavior.Analyzers.Views {
  [View("ConvexHull View")]
  [Content(typeof(PermutationSolutionDictionary), false)]
  public partial class ConvexHullView : ItemView {
    public ConvexHullView() {
      InitializeComponent();
    }

    public new PermutationSolutionDictionary Content {
      get { return (PermutationSolutionDictionary)base.Content; }
      set { base.Content = value; }
    }

    protected override void OnContentChanged() {
      base.OnContentChanged();

      if (Content != null) { }
    }

    private void testConvexHullButton_Click(object sender, System.EventArgs e) {
      var sols = Content.GetSolutionsFromGeneration(1);
      var input = sols.Select(x => ConvertPermutationToVertex(x.GetPermutation()));
      var result = ConvexHull.Create(input);
      //TODO
    }

    private DefaultVertex ConvertPermutationToVertex(Permutation p) {
      DefaultVertex vertex = new DefaultVertex();
      vertex.Position = p.Select(x => (double)x).ToArray();
      return vertex;
    }
  }
}
